﻿using System;
using System.Collections.Generic;
using System.Drawing;
using System.Globalization;
using System.IO;
using System.Runtime.InteropServices;
using System.Text;
using ConnectDT2Report.Properties;
using GrapeCity.ActiveReports;
using GrapeCity.ActiveReports.Extensibility;

namespace ConnectDT2Report
{
    internal sealed class MySubreportLocator : ResourceLocator
    {
        private const string UriSchemeMySubreports = "MySubreport:";
        /// <summary>
        /// Obtain and return the resource. 
        /// </summary>
        /// <param name="resourceInfo">The information about the resource to be obtained. </param>
        /// <returns>The resource, null if it was not found. </returns>
        public override Resource GetResource(ResourceInfo resourceInfo)
        {
            Resource resource;
            string name = resourceInfo.Name;

            Uri uri = new Uri(name);
            if (uri.GetLeftPart(UriPartial.Scheme).StartsWith(UriSchemeMySubreports, true, CultureInfo.InvariantCulture))
            {
                PageReport pr = new PageReport(new System.IO.FileInfo(name.Replace(UriSchemeMySubreports,"").Trim()));
                pr.Report.DataSources[0].ConnectionProperties.DataProvider = "OLEDB";
                pr.Report.DataSources[0].ConnectionProperties.ConnectString = @"data source=C:\Users\stduser\Documents\ComponentOne Samples\ActiveReports 8\Data\reels.MDB;provider=Microsoft.Jet.OLEDB.4.0;";

                System.IO.MemoryStream memory_stream = new System.IO.MemoryStream();
                using (System.Xml.XmlWriter writer = System.Xml.XmlWriter.Create(memory_stream))
                {
                    pr.Save(writer);
                }
                memory_stream.Position = 0;
                resource = new Resource(memory_stream, uri);
            }
            else
            {
                
            }
            return resource;
        }
    }
}
